//
// This file contains a simple trace function which is called from the
// state machine code if the command line switch -Trace is given
//

#include "light_ext.h"
#include "light.h"
#include "light_trace.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>

#define BUFLEN 128
#define SRV_IP "127.0.0.1"
#define PORT 4445  // must be same as in codegen.cfg

struct sockaddr_in si_other;
int s, i, slen=sizeof(si_other);
char buf[BUFLEN];

// call once to init trace via UDP
void initUdpTrace(){
	if ((s=socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP))==-1){
		perror("socket");
		exit(1);
	}

	memset((char *) &si_other, 0, sizeof(si_other));
	si_other.sin_family = AF_INET;
	si_other.sin_port = htons(PORT);
	if (inet_aton(SRV_IP, &si_other.sin_addr)==0) {
  		perror("inet_aton() failed\n");
  		exit(1);
  	}
}

void lightTraceEvent(LIGHT_EVENT_T evt){
	int i;
	printf("Processed event: %s\n", lightTraceEvents[evt]);

	i=sprintf(buf,lightTraceEvents[evt]);
	
	//i=sprintf(buf,"__RESET__");
	if (sendto(s, buf, i, 0, &si_other, slen)==-1){
		perror("sendto()");
	}
}


void sendReset(){
	printf("Send Reset Message\n");
	i=sprintf(buf,"__RESET__");
	if (sendto(s, buf, i, 0, &si_other, slen)==-1){
		perror("sendto()");
	}
}